<template>
    <BasicLayout>
        <template #wrapper>
            <el-card class="box-card">
                <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
                    <el-form-item label="通道" prop="platformCode"><el-select v-model="queryParams.platformCode"
                            placeholder="通道" clearable size="small">
                            <el-option v-for="dict in platformCodeOptions" :key="dict.value" :label="dict.label"
                                :value="dict.value" />
                        </el-select>
                    </el-form-item>
                    <el-form-item label="电话号码" prop="phone"><el-input v-model="queryParams.phone" placeholder="请输入电话号码"
                            clearable size="small" @keyup.enter.native="handleQuery" />
                    </el-form-item>

                    <el-form-item>
                        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
                    </el-form-item>
                </el-form>

                <el-row :gutter="10" class="mb8">
                    <el-col :span="1.5">
                           <el-popconfirm class="delete-popconfirm" title="确认要同步吗?" confirm-button-text="同步"
                                @confirm="handleSync()">
                                <el-button slot="reference" v-permisaction="['admin:smsAbnormalNumber:sync']"
                                    size="mini" type="primary" :loading="loading">同步
                                </el-button>
                            </el-popconfirm>
                    </el-col>
                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:smsAbnormalNumber:remove']" type="danger"
                            icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete">删除
                        </el-button>
                    </el-col>
                </el-row>

                <el-table v-loading="loading" :data="smsAbnormalNumberList" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" align="center" />

                    <el-table-column label="平台" align="center" prop="platformCode" :formatter="platformCodeFormat"
                        width="100">
                        <template slot-scope="scope">
                            {{ platformCodeFormat(scope.row) }}
                        </template>
                    </el-table-column>
                    <el-table-column label="账号" align="center" prop="account" :show-overflow-tooltip="true" />
                    <el-table-column label="电话号码" align="center" prop="phone" :show-overflow-tooltip="true" />
                    <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                        <template slot-scope="scope">
                            <el-popconfirm class="delete-popconfirm" title="确认要删除吗?" confirm-button-text="删除"
                                @confirm="handleDelete(scope.row)">
                                <el-button slot="reference" v-permisaction="['admin:smsAbnormalNumber:remove']"
                                    size="mini" type="text" icon="el-icon-delete">删除
                                </el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageIndex"
                    :limit.sync="queryParams.pageSize" @pagination="getList" />

            </el-card>
        </template>
    </BasicLayout>
</template>

<script>
import { delSmsAbnormalNumber, listSmsAbnormalNumber,syncStateAbnormalNumber } from '@/api/admin/sms-abnormal-number'

export default {
    name: 'SmsAbnormalNumber',
    components: {
    },
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 总条数
            total: 0,
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            isEdit: false,
            // 类型数据字典
            typeOptions: [],
            smsAbnormalNumberList: [],
            platformCodeOptions: [],
            // 关系表类型

            // 查询参数
            queryParams: {
                pageIndex: 1,
                pageSize: 10,
                platformCode: undefined,
                phone: undefined,

            },
            // 表单参数
            form: {
            },
            // 表单校验
            rules: {
                platformCode: [{ required: true, message: '平台code不能为空', trigger: 'blur' }],
                phone: [{ required: true, message: '电话号码不能为空', trigger: 'blur' }],
            }
        }
    },
    created() {
        this.getList()
        this.getDicts('sms_platform').then(response => {
            this.platformCodeOptions = response.data
        })
    },
    methods: {
        /** 查询参数列表 */
        getList() {
            this.loading = true
            listSmsAbnormalNumber(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
                this.smsAbnormalNumberList = response.data.list
                this.total = response.data.count
                this.loading = false
            }
            )
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {

                id: undefined,
                account: undefined,
                platformCode: undefined,
                phone: undefined,
            }
            this.resetForm('form')
        },
        getImgList: function () {
            this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
        },
        fileClose: function () {
            this.fileOpen = false
        },
        platformCodeFormat(row) {
            return this.selectDictLabel(this.platformCodeOptions, row.platformCode)
        },
        // 关系
        // 文件
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageIndex = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.dateRange = []
            this.resetForm('queryForm')
            this.handleQuery()
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加异常号码统计'
            this.isEdit = false
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map(item => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            var Ids = (row.id && [row.id]) || this.ids

            this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(function () {
                return delSmsAbnormalNumber({ 'ids': Ids })
            }).then((response) => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.open = false
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            }).catch(function () {
            })
        },
        handleSync(){
            this.loading=true

            syncStateAbnormalNumber().then(response => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            })
            .catch(err=>{
                console.log("err:",err)
            })
            .finally(()=>{
                this.loading=false
            })
        }
    }
}
</script>
